// Det Arb Partial de Cost Minim ( Minimum Spanning Tree)
// O(E log E)
// Arb minim de acoperire
#include <algorithm>
#include <fstream>
#include <vector>
using namespace std;

ifstream fin("kruskal.in");
ofstream fout("kruskal.out");


struct Edge {
    int x, y, w;
    Edge(int x, int y, int w) :
		x {x}, y {y}, w{w}
    {}
    bool operator < (const Edge& e) const {
        return w < e.w;
    }
};

class DS {
public:
    DS(int n): t(n)
    {
        for (int i = 0; i < n; ++i)
            t[i] = i;
    }

    int& operator[](int x)
    {
        int y, p;
        for (y = x; y != t[y]; y = t[y]);

        while (x != y)
        {
            p = t[x];
            t[x] = y;
            x = p;
        }
        return t[y];
    }
private:
    vector<int> t;
};

void Read();
void Write();
void Kruskal();

vector<Edge> edges, apm;
int64_t cmin;
int n;

int main()
{
	Read();
	Kruskal();
	Write();
}

void Kruskal()
{
    sort(edges.begin(), edges.end());    // O(m * log m)
	DS t(n + 1);
    int cnt = 0;
    for ( const Edge& e : edges ) // O(n)
		if (t[e.x] != t[e.y])
		{
		    t[e.x] = t[e.y];
			cmin += e.w;
			apm.push_back(e);
			cnt++;
			if ( cnt == n - 1 )
				break;
		}
}

void Read()
{
    fin >> n;
    int x, y, cost;
    while ( fin >> x >> y >> cost )
        edges.push_back(Edge(x, y, cost));
    fin.close();
}

void Write()
{
    fout << "Costul minim: " << cmin << '\n';
    for ( auto& e :  apm)
        fout << e.x << ' ' << e.y << ' ' << e.w << '\n';
}
