// https://www.infoarena.ro/problema/subsecvente2
#include <fstream>
#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

int Lmax(int nod);

ifstream fin("subsecvente.in");
ofstream fout("subsecvente.out");

struct Nod {
	Nod() : msk(0), fs(0), fd(0)
	{}

	short msk;       /// bitul i retine daca exista un cuvant din sirul s[i] care se termina pe acest nod
	Nod  *fs, *fd;
};

int n, lg, j, s;
string a;
Nod *root;

int Lmax(Nod* nod);
void Insert(Nod* &nod, int i, int j);   // insereaza in arbore secventa [a[i], ..., a[j]] din a

int main()
{
	fin >> n;

    root = new Nod();
    root->msk = (1 << n) - 1;

    /*
     * pentu fiecare sir, plasam in trie toate secventele de lungime max 60
     */
    for (s = 0; s < n ; ++s)    // s - nr de ordine al sirului curent "a"
    {
		fin >> a; lg = a.size();

		for (int i = 0; i < lg; i++) // inserez in trie toate secventele de lungime maxim 60
        {
            j = min(i + 59, lg - 1);

			Insert(root, i, j); // a[i] ... a[j]
        }
    }

    fout << Lmax(root) - 1; // muchia cea mai de jos a lantului trebuie eliminata,
                            // pt ca litera corespunzatoare nu exista in toate sirurile date

    return 0;
}

void Insert(Nod* &nod, int i, int j)
{
	if (i > j) return;
	if (nod == 0)
		nod = new Nod();

	if (nod != root)
		nod->msk |= 1 << s;  // retinem ca secventa curenta din sirul s trece prin nodul curent

	if (a[i] == 'a')
		Insert(nod->fs, i + 1, j);
	else
		Insert(nod->fd, i + 1, j);
}

int Lmax(Nod* nod)
{
    if (nod == 0 || nod->msk != (1 << n) - 1) // daca pe nodul curent nu se termina secvente luate din toate sirurile
		return 0;                             // suntem cu un nivel mai jos in arbore, decat trebuie

    int la = Lmax(nod->fs);
    int lb = Lmax(nod->fd);

    return max(la, lb) + 1; // maximul lungimii fiilor + o muchie
}
